#!/bin/bash
echo "---------------------------------------------------------------------"
echo "--                 CCN-STIC-826-NEXTCLOUD-PASO 2                   --"
echo "--          SECURIZACIÓN DE PARÁMETROS Y MÓDULOS APACHE2           --"
echo "--  Antes de ejecutar este script debe asegurarse que los ficheros --"
echo "--       y scripts se encuentran en el directorio /Scripts         --"
echo "---------------------------------------------------------------------"
echo -e "\n"
echo "El script creará una copia de eliminará toda configuración en los siguientes ficheros: "
echo "'/etc/httpd/conf/httpd.conf' y '/etc/httpd/conf.d/nextcloud.conf'"
echo "Así mismo, se creará una copia de seguridad de los mismos en sus respectivas"
echo "carpetas con la siguiente nomenclatura .bak.fecha"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar....."
echo "EL PROCESO PUEDE DURAR VARIOS MINUTOS, ESPERE..."
##########Apache y mariaDB
yum -y install mod_security mod_evasive &>/dev/null
yum -y install mod_ssl &>/dev/null
systemctl enable httpd
systemctl start httpd
tiempo=$( date +"%d-%b-%y-%H:%M:%S" )
####FICHERO DE CONF APACHE####
mv /etc/httpd/conf/httpd.conf /etc/httpd/conf/httpd.conf.bak_$tiempo
cat > /etc/httpd/conf/httpd.conf << EOF
ServerRoot "/etc/httpd"

Listen 80

Include conf.modules.d/*.conf

User apache
Group apache


ServerAdmin root@localhost


<Directory />
   Deny from all
   Order allow,deny
   Satisfy all
   #AllowOverride None
   #Require all granted
</Directory>


DocumentRoot "/var/www/html"

<Directory "/var/www">
    Deny from all
    Order allow,deny
    Satisfy all
    #AllowOverride None
    #Require all granted
</Directory>

<Directory "/var/www/html">
    Order Deny,Allow
    Allow from all
    Options Indexes FollowSymLinks
    AllowOverride None
    Require all granted
</Directory>

<IfModule dir_module>
    DirectoryIndex index.html
</IfModule>

<Files ".ht*">
    Require all denied
</Files>

ErrorLog "logs/error_log"

LogLevel warn

<IfModule log_config_module>
    	#LogFormat "%h %l %u %t \"%r\" %>s %b \"%{Referer}i\" \"%{User-Agent}i\"" combined
    	#LogFormat "%h %l %u %t \"%r\" %>s %b" common
	LogFormat "%{X-Forwarded-For}i %l %u %t \"%r\" %>s %b \"%{Referer}i\" \"%{User-Agent}i\"" combined
	LogFormat "%h %l %u %t \"%r\" %>s %b" common
	LogFormat "%{Referer}i -> %U" referer
	LogFormat "%{User-agent}i" agent
    <IfModule logio_module>
    	#LogFormat "%h %l %u %t \"%r\" %>s %b \"%{Referer}i\" \"%{User-Agent}i\" %I %O" combinedio
   	LogFormat "%{X-Forwarded-For}i %l %u %t \"%r\" %>s %b \"%{Referer}i\" \"%{User-Agent}i\"" combined
	LogFormat "%h %l %u %t \"%r\" %>s %b" common
	LogFormat "%{Referer}i -> %U" referer
	LogFormat "%{User-agent}i" agent
	</IfModule>


    CustomLog "logs/access_log" combined
</IfModule>

<IfModule alias_module>


    ScriptAlias /cgi-bin/ "/var/www/cgi-bin/"

</IfModule>

<Directory "/var/www/cgi-bin">
    AllowOverride None
    Options None
    Require all granted
</Directory>

<IfModule mime_module>
    TypesConfig /etc/mime.types

    AddType application/x-compress .Z
    AddType application/x-gzip .gz .tgz



    AddType text/html .shtml
    AddOutputFilter INCLUDES .shtml
</IfModule>

AddDefaultCharset UTF-8

<IfModule mime_magic_module>
    MIMEMagicFile conf/magic
</IfModule>

### CONFIGURACION GLOBAL ##
      ServerRoot "/etc/httpd"
      PidFile /var/run/httpd.pid
      KeepAlive On
      MaxKeepAliveRequests 0
      KeepAliveTimeout 15
      MinSpareServers 16
      MaxSpareServers 64
      StartServers 16
      MaxClients 512
      MaxRequestsPerChild 100000
      EnableSendfile on
      ServerSignature Off
      ServerTokens Prod
      TraceEnable off
      
##clickjacking attack##
#Este apartado no es necesario en las últimas versiones de apache
#     Header always append X-Frame-Options SAMEORIGIN

##X-XSS Protection##

Header set X-XSS-Protection "1; mode=block"

##Tiempo de bloqueo##

Timeout 60
IncludeOptional conf.d/*.conf
EOF
gnome-text-editor /etc/httpd/conf/httpd.conf &>/dev/null
####FICHERO DE CONF NEXTCLOUD
mv /etc/httpd/conf.d/nextcloud.conf /etc/httpd/conf.d/nextcloud.conf.bak_$tiempo
cat > /etc/httpd/conf.d/nextcloud.conf << EOF
Alias /nextcloud "/var/www/html/nextcloud/"

    <Directory /var/www/html/nextcloud/>
      Options +FollowSymlinks
      AllowOverride All

     <IfModule mod_dav.c>
      Dav off
     </IfModule>

     SetEnv HOME /var/www/html/nextcloud
     SetEnv HTTP_HOME /var/www/html/nextcloud

    </Directory>

### dominio ###
	NameVirtualHost localhost:80
	<VirtualHost localhost:80>
		#ServerAdmin webmaster@dominio
		DocumentRoot /var/www/html/nextcloud
		#ServerName www.dominio
		#ServerAlias dominio
		Redirect 301 / https://localhost/nextcloud
		CustomLog logs/dominio-access_log combined
		Errorlog logs/dominio-error_log
	</VirtualHost>

	NameVirtualHost localhost:443
	<VirtualHost localhost:443>
		#ServerAdmin webmaster@dominio
		DocumentRoot /var/www/html/nextcloud
		#ServerName www.dominio
		<IfModule mod_headers.c>
						 Header always set Strict-Transport-Security "max-age=15552000; includeSubDomains"
                         Header set X-Content-Type-Options "nosniff"
                         Header set X-XSS-Protection "1; mode=block"
                         Header set X-Robots-Tag "none"
                         Header set X-Download-Options "noopen"
                         Header set X-Permitted-Cross-Domain-Policies "none"
                         SetEnv modHeadersAvailable true
		</IfModule>
		ScriptAlias /cgi-bin/ /var/www/html/nextcloud/cgi-bin/
		<Directory "/var/www/dominio/cgi-bin">
			SSLOptions +StdEnvVars
		</Directory>
		SSLEngine on
		SSLProtocol all -SSLv2 -SSLv3
		SSLCipherSuite ALL:!ADH:!EXPORT:!SSLv2:RC4+RSA:+HIGH:+MEDIUM:+LOW
		SSLCertificateFile /etc/pki/tls/certs/localhost.crt
		SSLCertificateKeyFile /etc/pki/tls/private/localhost.key
		#SSLCertificateKeyFile /etc/pki/tls/private/dominio.pem
		SetEnvIf User-Agent ".*MSIE.*" nokeepalive ssl-unclean-shutdown downgrade-1.0 force-response-1.0
		CustomLog logs/dominio-ssl_request_log "%t %h %{SSL_PROTOCOL}x %{SSL_CIPHER}x \"%r\" %b"
		Errorlog logs/dominio-ssl_error_log
		TransferLog logs/dominio-ssl_access_log
		LogLevel warn
	</VirtualHost>
EOF


echo "Se muestra el fichero '/etc/httpd/conf.d/nextcloud.conf' para su comprobación"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar....."
gnome-text-editor /etc/httpd/conf.d/nextcloud.conf &>/dev/null
echo "ahora se reiniciará el servidor Apache2, compruebe que reinicia sin errores"
systemctl restart httpd
systemctl status httpd
